diff -NaurdbB -xCVS -xconfigure$ -xconfig.h.in -xMakefile.in mrbayes-3.1.2.old/mcmc.c mrbayes-3.1.2.new/mcmc.c
--- mrbayes-3.1.2.old/mcmc.c	Wed Apr 18 12:19:46 EDT 2007
+++ mrbayes-3.1.2.new/mcmc.c	Thu Nov 22 12:52:14 EST 2007
@@ -27675,15 +28528,65 @@
 	/* get model params */
 	mp = &modelParams[param->relParts[0]];
 	
+	/* get old values of switching rates */
+	value = GetParamVals(param, chain, state[chain]);
+
+
 	/* get minimum and maximum values for switching rate */
-	if (param->paramId == SWITCH_UNI)
-		{
+	if (param->paramId == SWITCH_UNI) {
 		minS = mp->covswitchUni[0];
 		maxS = mp->covswitchUni[1];
 		isSPriorExp = NO;
+        } else if (param->paramId == SWITCH_PINVUNI) { /* - Allen */
+	  minS = mp->covswitchUni[0];
+	  maxS = mp->covswitchUni[1];
+	  isSPriorExp = NO;
+	  if (whichRate == 1) {
+	    /* maximum for s10 that will give mp->covswitchMaxPinvar stationary ProbOff */
+	    tmpS = (value[0]*mp->covswitchMaxPinvar)/(1-mp->covswitchMaxPinvar);
+	    if (maxS > tmpS) {
+	      if (tmpS < minS) { /* Shouldn't happen! */
+	        MrBayesPrint ("%s   ERROR: tmpS %1.2lf minS %1.2lf s01 %1.2lf\n", spacer, tmpS, minS,
+			      value[0]);
+		return (ERROR);
+	      } else if (tmpS == minS) {
+		whichRate = 0;
+		tmpS = (value[1]*(1-mp->covswitchMaxPinvar))/mp->covswitchMaxPinvar;
+		if (minS < tmpS) {
+		  if (tmpS >= maxS) {
+		    MrBayesPrint ("%s   ERROR: tmpS %1.2lf maxS %1.2lf s01 %1.2lf s10 %1.2lf\n", spacer, tmpS, maxS,
+				  value[0],value[1]);
+		    return (ERROR);
+		  } else
+		    minS = tmpS;
 		}
-	else
-		{
+	      } else
+		maxS = tmpS;
+            }
+	  } else {
+	    /* minimum for s01 that will give mp->covswitchMaxPinvar stationary ProbOff */
+	    tmpS = (value[1]*(1-mp->covswitchMaxPinvar))/mp->covswitchMaxPinvar;
+	    if (minS < tmpS) {
+	      if (tmpS > maxS) {
+		MrBayesPrint ("%s   ERROR: tmpS %1.2lf maxS %1.2lf s10 %1.2lf\n", spacer, tmpS, maxS,
+			      value[1]);
+		return (ERROR);
+	      } else if (tmpS == maxS) {
+		whichRate = 1;
+		tmpS = (value[0]*mp->covswitchMaxPinvar)/(1-mp->covswitchMaxPinvar);
+		if (maxS > tmpS) {
+		  if (tmpS <= minS) { /* Shouldn't happen! */
+		    MrBayesPrint ("%s   ERROR: tmpS %1.2lf minS %1.2lf s01 %1.2lf s10 %1.2lf\n", spacer, tmpS, minS,
+				  value[0],value[1]);
+		    return (ERROR);
+		  } else
+		    maxS = tmpS;
+		}
+	      } else
+	        minS = tmpS;
+            }
+          }
+	} else {
 		minS = 0.01;
 		maxS = KAPPA_MAX;
 		sExp = mp->covswitchExp;
@@ -27691,7 +28594,6 @@
 		}
 
 	/* get old value of switching rate */
-	value = GetParamVals(param, chain, state[chain]);
 	newS = oldS = value[whichRate];
 
 	/* change value for switching rate */
@@ -29277,7 +30179,8 @@
 {
 
 	int				c, i, k, nStates;
-	MrBFlt			*bs, freq;
+	MrBFlt			*bs, freq, covBF[40];
+	MrBFlt                  s01=50.0, s10=50.0, probOn, probOff, *swr;
 	CLFlt			*clFP, *cL, sum;
 	char			*tempStr;
 	int             tempStrSize = 200;
@@ -29299,6 +30202,29 @@
 	/* find number of states */
 	nStates = m->numModelStates;
 	
+	/* if covarion model, adjust base frequencies */
+        if (m->switchRates != NULL) { /* code from Likelihood_Gen - Allen */
+	  /* find the stationary frequencies */
+	  swr = GetParamVals(m->switchRates, chain, state[chain]);
+	  s01 = swr[0];
+	  s10 = swr[1];
+	  probOn = s01 / (s01 + s10);
+	  probOff =  1.0 - probOn;
+	  
+	  /* now adjust the base frequencies; on-state stored first in cond likes */
+	  for (i=0; i<(nStates/2); i++) {
+	    covBF[i] = bs[i] * probOn;
+	    /* try to reduce numerical inaccuracy - Allen */
+	    covBF[i+(nStates/2)] = bs[i] - covBF[i];
+	    if (covBF[i+(nStates/2)] < LIKE_EPSILON)
+	      covBF[i+(nStates/2)] = bs[i] * probOff;
+	  }
+	  
+	  /* finally set bs pointer to adjusted values */
+	  bs = covBF;
+	}
+
+
 	/* find frequencies of rate categories */
 	freq =  1.0 /  m->numGammaCats;
 	
@@ -29334,18 +30260,23 @@
 		}
 
 	/* print the resulting conditional likelihoods cycling over uncompressed chars */
-	for (c=0; c<numChar; c++)
-		{
+	for (c=0; c<numChar; c++) {
 		if (charInfo[c].isExcluded == YES || charInfo[c].partitionId[partitionNum-1] != division+1)
 			continue;
 		i = compCharPos[c] - m->compCharStart;
 		cL = ancStateCondLikes + (i*nStates);
-		for (i=0; i<nStates; i++)
-			{
+		if (m->switchRates != NULL) {
+		  for (i=0; i<nStates/2; i++) { /* may later work on indicating covarion on/off... XXX - Allen */
+		    SaveSprintf (&tempStr, &tempStrSize, "%f\t", (cL[i]+cL[i+(nStates/2)]));
+		    if (AddToPrintString (tempStr) == ERROR) return (ERROR);
+		  }
+		} else {
+		  for (i=0; i<nStates; i++) {
 			SaveSprintf (&tempStr, &tempStrSize, "%f\t", cL[i]);
 			if (AddToPrintString (tempStr) == ERROR) return (ERROR);
 			}
 		}
+	}
 	free (tempStr);
 	return NO_ERROR;	
 
@@ -29625,6 +30556,11 @@
 	Tree			*t;
 	TreeNode		*p;
 
+#	if defined (MPI_ENABLED)
+	if (proc_id != 0)
+		return (NO_ERROR);
+#	endif
+
 	if (!chainCondLikes || !termCondLikes)
 		return ERROR;
 
@@ -29686,10 +30622,11 @@
 				MrBayesPrint ("\n");
 				}
 			MrBayesPrint("\n");
+#	if (!defined (MPI_ENABLED))
 			if ((c-m->condLikeStart)% 8 == 0)
 				getchar();
+#endif
 			}
-				
 		}	/* next division */
 
 	return NO_ERROR;
@@ -29722,6 +30659,11 @@
 	extern char		WhichStand (int x);
 
 
+#	if defined (MPI_ENABLED)
+	if (proc_id != 0)
+		return (NO_ERROR);
+#	endif
+
 	if (!compMatrix)
 		return ERROR;
 
@@ -29842,8 +30784,10 @@
 				}
 			MrBayesPrint ("\n\n");
 			}
+#if (! defined(MPI_ENABLED))
 		MrBayesPrint ("Press return to continue\n");
 		getchar();
+#endif
 		}	/* next division */
 
 	return NO_ERROR;
@@ -29872,6 +30816,10 @@
 	extern char		WhichRes (int x);
 	extern char		WhichStand (int x);
 
+#	if defined (MPI_ENABLED)
+	if (proc_id != 0)
+		return (NO_ERROR);
+#	endif
 
 	if (!matrix)
 		return ERROR;
@@ -30065,8 +31013,10 @@
 			{
 			for (i=0; i<chainParams.numChains; i++)
 				{
-				for (j=i+1; j<chainParams.numChains; j++)
-					{
+				  for (j=i+1; j<chainParams.numChains; j++) {
+				    if (swapInfo[n][j][i] < 1)
+				      MrBayesPrintf (fpMcmc, "\tN/A");
+				    else
 					MrBayesPrintf (fpMcmc, "\t%.6f", (MrBFlt) swapInfo[n][i][j] / (MrBFlt) swapInfo[n][j][i]);
 					}
 				}
@@ -30241,7 +31191,7 @@
 	MrBFlt			freq, siteLike, invLike, catLike, pInvar=0.0, *bs,
 					*clInvar=NULL, *catRate, baseRate;
 	MrBFlt			s01, s10, probOn, probOff, *swr, covBF[40];
-	CLFlt			*lnScaler, *clP, *siteRates;
+	CLFlt			*clP, *siteRates, *lnScaler;
 	char			*tempStr;
 	int             tempStrSize = 200;
 	ModelInfo		*m;
@@ -31438,8 +32388,8 @@
 					maxNumExchanges = swapInfo[n][i][j];
 		SaveSprintf(&tempStr, &tempStrSize, "%d", maxNumExchanges);
 		maxLen = (int) strlen(tempStr);
-		if (maxLen < 4)
-			maxLen = 4;
+		if (maxLen < 8) /* from 4 - Allen */
+			maxLen = 8;
 			
 		reweightingChars = NO;
 		if ((chainParams.weightScheme[0] + chainParams.weightScheme[1]) > 0.00001)
@@ -31480,10 +32430,10 @@
 						MrBayesPrint ("%*c%s ", maxLen-3, ' ', " N/A");
 						}
 					else
-						{
-						SaveSprintf(&tempStr, &tempStrSize, "%1.2lf", (MrBFlt)swapInfo[n][i][j]/swapInfo[n][j][i]);
+					  { /* from %1.2lf - Allen */
+						SaveSprintf(&tempStr, &tempStrSize, "%1.6lf", (MrBFlt)swapInfo[n][i][j]/swapInfo[n][j][i]);
 						len = (int) strlen(tempStr);
-						MrBayesPrint ("%*c%1.2lf ", maxLen-len+1, ' ', (MrBFlt)swapInfo[n][i][j]/swapInfo[n][j][i]);
+						MrBayesPrint ("%*c%1.6lf ", maxLen-len+1, ' ', (MrBFlt)swapInfo[n][i][j]/swapInfo[n][j][i]);
 						}
 					}
 				else if (i == j)
@@ -31629,7 +32579,7 @@
 ---------------------------------------------------*/
 void PrintTiProbs (MrBFlt *tP, MrBFlt *bs, int nStates)
 
-{
+{ /* Why is it MrBFlt not CLFlt? - Allen */
 	int		i, j;
 	MrBFlt	*tiP, sum;
 
@@ -31776,12 +32726,22 @@
 }
 
 
-void PrintToScreen (int curGen, time_t endingT, time_t startingT)
+void PrintToScreen (int curGen, int movesAccepted, time_t endingT, time_t startingT)
 {
 
 	int			i, chn, nHours, nMins, nSecs;
 	MrBFlt		timePerGen;
-
+#if defined(UNIX_VERSION)
+	time_t endtime_secs; /* UNIX_VERSION b/c uncertain on time handling otherwise - Allen */
+	struct tm *tmbuf;
+	static char *dayname[] = {"Sun", "Mon", "Tue", "Wed", "Thu", "Fri",
+				  "Sat"};
+	static char *monname[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun",
+				  "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
+	/* My apologies about the fixed English-language names,
+	   but asctime's inbuilt return was problematic (I use Perl for
+	   string-handling programs...) - Allen */
+#endif
 #	if defined (MPI_ENABLED)
 	int			numLocalColdChains, numFirstAndLastCold;
 	
@@ -31790,7 +32750,7 @@
 		MrBayesPrint ("\n");
 		MrBayesPrint ("%s   Chain results:\n\n", spacer);
 		}
-	MrBayesPrint ("%s   %4d -- ", spacer, curGen);
+	MrBayesPrint ("%s   %5d -- ", spacer, curGen);
 	numLocalColdChains = numFirstAndLastCold = 0;
 	for (chn=0; chn<numLocalChains; chn++)
 		{
@@ -31841,8 +32801,7 @@
 	else
 		MrBayesPrint ("[...%d remote chains...] ", (chainParams.numChains*chainParams.numRuns) - numLocalChains);
 
-	if (curGen > 1)
-		{
+	if (curGen > 1) {
 		timePerGen = (MrBFlt) ((MrBFlt)(endingT-startingT)/(MrBFlt)curGen);
 		nSecs = (int)((chainParams.numGen - curGen) * timePerGen);
 		nHours = (int)nSecs / 3600;
@@ -31850,6 +32809,20 @@
 		nMins = nSecs / 60; 
 		nSecs -= nMins * 60;
 		MrBayesPrint ("-- %d:%0.2d:%0.2d", nHours, nMins, nSecs);
+#if defined(UNIX_VERSION)
+		if ((nHours > 0) || (nMins > 0)) {
+		  endtime_secs = time(0) + (time_t)((chainParams.numGen - curGen) * timePerGen);
+		  tmbuf = localtime(&endtime_secs); /* Code from Perl - Allen */
+		  MrBayesPrint(" -- Estimated Endtime: %s %s %2d %02d:%02d:%02d %d",
+			       dayname[tmbuf->tm_wday],
+			       monname[tmbuf->tm_mon],
+			       tmbuf->tm_mday,
+			       tmbuf->tm_hour,
+			       tmbuf->tm_min,
+			       tmbuf->tm_sec,
+			       tmbuf->tm_year + 1900);
+		}
+#endif
 		}
 	MrBayesPrint ("\n");
 	fflush (stdout);
@@ -31861,7 +32834,8 @@
 		MrBayesPrint ("\n");
 		MrBayesPrint ("%s   Chain results:\n\n", spacer);
 		}
-	MrBayesPrint ("%s   %5d -- ", spacer, curGen);
+	MrBayesPrint ("%s   %5d (%5d; %6.4lf %%) -- ", spacer, curGen, movesAccepted,
+		      (double)(((double)movesAccepted*100.0)/(double)curGen));
 	if (numLocalChains == 1)
 		MrBayesPrint ("%1.3lf ", curLnL[0]);
 	else
@@ -31900,8 +32874,7 @@
 			}
 		}
 		
-	if (curGen > 1)
-		{
+	if (curGen > 1) {
 		timePerGen = (MrBFlt) ((MrBFlt)(endingT-startingT)/(MrBFlt)curGen);
 		nSecs = (int)((chainParams.numGen - curGen) * timePerGen);
 		nHours = (int)nSecs / 3600;
@@ -31909,6 +32882,20 @@
 		nMins = nSecs / 60; 
 		nSecs -= nMins * 60;
 		MrBayesPrint ("-- %d:%0.2d:%0.2d", nHours, nMins, nSecs);
+#if defined(UNIX_VERSION)
+		if ((nHours > 0) || (nMins > 0)) {
+		  endtime_secs = time(0) + (time_t)((chainParams.numGen - curGen) * timePerGen);
+		  tmbuf = localtime(&endtime_secs); /* Code from Perl - Allen */
+		  MrBayesPrint(" -- Estimated Endtime: %s %s %2d %02d:%02d:%02d %d",
+			       dayname[tmbuf->tm_wday],
+			       monname[tmbuf->tm_mon],
+			       tmbuf->tm_mday,
+			       tmbuf->tm_hour,
+			       tmbuf->tm_min,
+			       tmbuf->tm_sec,
+			       tmbuf->tm_year + 1900);
+		}
+#endif
 		}
 	MrBayesPrint ("\n");
 	
@@ -32960,7 +33947,7 @@
 
 
 
-
+#if !defined(ALTSCALING)
 /*-------------------------------------------------------------------
 |
 |	ResetScalers: reset scaler nodes of all trees of all chains
@@ -32983,11 +33970,12 @@
 			t = GetTreeFromIndex (i, chn, state[chn]);
 		
 			/* set the node depth value of terminal nodes to zero */
-			for (n=0; n<t->nNodes; n++)
-				{
+			for (n=0; n<t->nNodes; n++) {
 				p = t->allDownPass[n];
-				if (p->left == NULL)
+			  if (p->left == NULL) {
 					p->x = 0;
+			    p->scalerNode = NO; /* just in case - Allen */
+			  }
 				}
 
 			/* loop over interior nodes */
@@ -33010,8 +33998,7 @@
 
 	return NO_ERROR;
 }
-
-
+#endif
 
 
 
@@ -33084,8 +34071,15 @@
 {
 	
 	int		i, j, k, n, chn, swapA=0, swapB=0, whichMove, acceptMove, lastDiagnostics, stopChain,
-			nErrors;
+			nErrors, burninGen=250000, partBurninGen1, partBurninGen2, partBurninGen=125000, tempZero, tempUse,
+	                tempUse1, tempUse2, adaptNarrow=NO, adaptWiden=NO, timesAdaptNarrow=0,timesAdaptWiden=0,
+	                movesAccepted=0, timesAdaptNarrowAccepted=0, timesAdaptNarrowRefused=0, adaptOnlyIfBack=NO,
+	                timesAdaptWidenAccepted=0, timesAdaptWidenRefused=0, adaptDidNarrow=NO, adaptDidWiden=NO,
+	                didReportPartBurnin=NO, didReportBurnin=NO;
 	MrBFlt		r=0.0, lnLikelihoodRatio, lnPriorRatio, lnProposalRatio, lnLike=0.0, lnPrior=0.0, f, CPUTime;
+	MrBFlt          mult_short=138.463, mult_long=69.2314, tempSubZero, effectiveGen, successRatio1, minParam;
+	MrBFlt          maxParam, adaptMult, adaptCFactor, newParam, currParam, minParamMult, maxParamMult, newParamMult;
+	MrBFlt          minAdaptCFactor, successRatio2, successRatioUse, origAdaptCFactor;
 	MCMCMove	*theMove, *mv;
 	time_t		startingT, endingT, stoppingT1, stoppingT2;
 	clock_t		previousCPUTime, currentCPUTime;
@@ -33368,12 +34362,77 @@
 #		endif
 		}
 
+	/* Initialize generation cutoffs, mults for Simulated Annealing, Adapt - Allen */
+	if (chainParams.useAdapt == YES) { /* setting these here to eliminate complaints from GCC */
+	  /* "higher" temps usable */
+	  tempZero = (int) ((1.0/(1.0+0.6))*1000.0);
+	  tempSubZero = 1.0 - (1.0/(1.0+0.6));
+	} else {
+	  /* 1/(1+0.2) as starting temperature (0.2 is default Temp for 1st of heated multiple chains) */
+	  tempZero = (int) ((1.0/(1.0+0.2))*1000.0);
+	  tempSubZero = 1.0 - (1.0/(1.0+0.2));
+	}
+	if ((chainParams.useSA == YES) ||
+	    (chainParams.useAdapt == YES)) { /* note that C casts from floating to integer truncate */
+	  if (chainParams.relativeBurnin == YES) {
+	    burninGen = (int) (chainParams.numGen*chainParams.burninFraction);
+	    if (chainParams.burninFraction < 0.25) {
+	      MrBayesPrint ("%s   burninGen is %d (burninFraction is %1.3lf); cannot do Simulated Annealing or Adapt\n",
+			    spacer, burninGen, chainParams.burninFraction);
+	      return ERROR;
+	    }
+	    partBurninGen1 = (int) (chainParams.numGen*chainParams.burninFraction*0.5);
+	    partBurninGen2 = (int) (chainParams.numGen*(chainParams.burninFraction-0.25));
+	  } else {
+	    burninGen = chainParams.chainBurnIn;
+	    if ((burninGen*4) < chainParams.numGen) {
+	      MrBayesPrint ("%s   burninGen is %d but numGen is %d; cannot do Simulated Annealing or Adapt\n",
+			    spacer, burninGen, chainParams.numGen);
+	      return ERROR;
+	    }
+	    partBurninGen1 = (int) (chainParams.chainBurnIn/2);
+	    partBurninGen2 = (int) (chainParams.chainBurnIn - (chainParams.numGen*0.25));
+	  }
+
+	  partBurninGen = partBurninGen1;
+	  if (partBurninGen2 > partBurninGen1)
+	    partBurninGen = partBurninGen2;
+
+	  if (burninGen <= partBurninGen) {
+	    MrBayesPrint ("%s   partBurninGen would be %d (burninGen is %d); cannot do Simulated Annealing or Adapt\n",
+			  spacer, partBurninGen, burninGen);
+	    return ERROR;
+	  }
+
+	  MrBayesPrint("%s   partBurninGen is %d, burninGen is %d\n",
+		       spacer, partBurninGen, burninGen);
+
+	  if (chainParams.useSA == YES) {
+	    if (partBurninGen <= 2) {
+	      MrBayesPrint ("%s   partBurninGen would be %d (burninGen is %d); cannot do Simulated Annealing\n",
+			    spacer, partBurninGen, burninGen);
+	      return ERROR;
+	    }
+
+	    MrBayesPrint("%s   tempSubZero is %.6lf, tempZero/1000 is %.3lf\n",
+			 spacer, tempSubZero, (double) ((double)tempZero/1000.0));
+
+	    /* such that at partBurninGen, will be 0 (mult 1) w/rounding, but starts at tempZero */
+	    mult_short = (0.001-tempSubZero)/(partBurninGen-1);
+	    /* ditto for burninGen */
+	    mult_long = (0.001-tempSubZero)/(burninGen-1);
+	    MrBayesPrint ("%s   mult_short is %.6lf, mult_long is %.6lf\n",
+			  spacer,mult_short,mult_long);
+	  }
+	}
 	/* get chain IDs */
 	GetChainIds ();
 	
 	/* initialize likelihoods and prior                  */
 	/* touch everything and calculate initial cond likes */
+#if !defined(ALTSCALING)
 	ResetScalers ();
+#endif
 	TouchAllPartitions ();
 	for (chn=0; chn<numLocalChains; chn++)
 		{
@@ -33413,6 +34472,10 @@
 	for (i=0; i<chainParams.numRuns; i++)
 		maxLnL0[i] = -100000000.0;
 
+#if defined(MPI_ENABLED) && defined(DEBUG_MPI) && LAM_MPI
+	MPIL_Trace_on();
+#endif
+
 	startingT=time(0);
 	CPUTime = 0.0;
 	previousCPUTime = clock();
@@ -33421,11 +34484,27 @@
 		{
 
 		currentCPUTime = clock();
-		if (currentCPUTime - previousCPUTime > 10 * CLOCKS_PER_SEC)
+		if (currentCPUTime < previousCPUTime) { /* wraparound - Allen */
+		  if ((currentCPUTime < 0) && (previousCPUTime > 0)) { /* Approximating */
+		    if (previousCPUTime > (-1*currentCPUTime)) {
+		      CPUTime += (2*(previousCPUTime + currentCPUTime)) / (MrBFlt) (CLOCKS_PER_SEC);
+		    } else {
+		      CPUTime += (-2*(previousCPUTime + currentCPUTime)) / (MrBFlt) (CLOCKS_PER_SEC);
+		    }
+		    previousCPUTime = currentCPUTime;
+		  } else {
+		    if ((previousCPUTime - currentCPUTime) >= CLOCKS_PER_SEC) {
+		      CPUTime += (previousCPUTime - currentCPUTime) / (MrBFlt) (CLOCKS_PER_SEC);
+		      previousCPUTime = currentCPUTime;
+		    }
+		  }
+		} else {
+		  if ((currentCPUTime - previousCPUTime) > 10 * CLOCKS_PER_SEC)
 			{
 			CPUTime += (currentCPUTime - previousCPUTime) / (MrBFlt) (CLOCKS_PER_SEC);
 			previousCPUTime = currentCPUTime;
 			}
+		}
 
 		/*! AbortRun is set by the signal handler when it receives a CTRL-C */
 #if 		defined  (MPI_ENABLED)
@@ -33435,11 +34514,14 @@
 		if (confirmAbortRun == YES && RequestAbortRun() == 1)
 			return ABORT;
 #endif
+
+#if !defined(ALTSCALING)
 		/* Refresh scalers every SCALER_REFRESH_FREQ generations.                */
 		/* It is done before copying so we know it will take effect immediately. */
 		/* However, the actual scalers are recalculated only when really needed. */
 		if (n % SCALER_REFRESH_FREQ == 0)
 			ResetScalers();
+#endif
 
 		for (chn=0; chn<numLocalChains; chn++)
 			{
